// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VrGraphs.pas' rev: 6.00

#ifndef VrGraphsHPP
#define VrGraphsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Menus.hpp>	// Pascal unit
#include <VrSysUtils.hpp>	// Pascal unit
#include <VrControls.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vrgraphs
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TVrBrushPattern { bpSolid, bpClear, bpHorizontal, bpVertical, bpFDiagonal, bpBDiagonal, bpCross, bpDiagCross };
#pragma option pop

class DELPHICLASS TVrPercentGraphItem;
class PASCALIMPLEMENTATION TVrPercentGraphItem : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Graphics::TColor FColor;
	double FValue;
	TVrBrushPattern FPattern;
	void __fastcall SetColor(Graphics::TColor Value);
	void __fastcall SetValue(double Value);
	void __fastcall SetPattern(TVrBrushPattern Value);
	
public:
	__fastcall virtual TVrPercentGraphItem(Classes::TCollection* Collection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=255};
	__property double Value = {read=FValue, write=SetValue};
	__property TVrBrushPattern Pattern = {read=FPattern, write=SetPattern, default=0};
public:
	#pragma option push -w-inl
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TVrPercentGraphItem(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVrPercentGraphItems;
class DELPHICLASS TVrPercentGraph;
class PASCALIMPLEMENTATION TVrPercentGraph : public Vrcontrols::TVrGraphicImageControl 
{
	typedef Vrcontrols::TVrGraphicImageControl inherited;
	
private:
	double FMaxValue;
	Graphics::TColor FOutlineColor;
	TVrPercentGraphItems* FSegments;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetOutlineColor(Graphics::TColor Value);
	void __fastcall SetSegments(TVrPercentGraphItems* Value);
	
protected:
	HIDESBASE virtual void __fastcall Changed(void);
	virtual void __fastcall UpdateGraph(void);
	__property double MaxValue = {read=FMaxValue};
	
public:
	__fastcall virtual TVrPercentGraph(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrPercentGraph(void);
	
__published:
	__property TVrPercentGraphItems* Segments = {read=FSegments, write=SetSegments};
	__property Graphics::TColor OutlineColor = {read=FOutlineColor, write=SetOutlineColor, default=16777215};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property Color  = {default=11307165};
	__property DragCursor  = {default=-12};
	__property DragKind  = {default=0};
	__property DragMode  = {default=0};
	__property Hint ;
	__property ParentColor  = {default=0};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible  = {default=1};
	__property OnClick ;
	__property OnContextPopup ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDock ;
	__property OnStartDrag ;
};


class PASCALIMPLEMENTATION TVrPercentGraphItems : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
public:
	TVrPercentGraphItem* operator[](int Index) { return Items[Index]; }
	
private:
	TVrPercentGraph* FPercentGraph;
	HIDESBASE TVrPercentGraphItem* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, TVrPercentGraphItem* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall TVrPercentGraphItems(TVrPercentGraph* PercentGraph);
	HIDESBASE TVrPercentGraphItem* __fastcall Add(void);
	__property TVrPercentGraphItem* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
public:
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TVrPercentGraphItems(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TVrOrientation { voHorizontal, voVertical };
#pragma option pop

class DELPHICLASS TVrPercentBar;
class PASCALIMPLEMENTATION TVrPercentBar : public TVrPercentGraph 
{
	typedef TVrPercentGraph inherited;
	
private:
	TVrOrientation FOrientation;
	void __fastcall SetOrientation(TVrOrientation Value);
	
protected:
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TVrPercentBar(Classes::TComponent* AOwner);
	
__published:
	__property TVrOrientation Orientation = {read=FOrientation, write=SetOrientation, default=1};
public:
	#pragma option push -w-inl
	/* TVrPercentGraph.Destroy */ inline __fastcall virtual ~TVrPercentBar(void) { }
	#pragma option pop
	
};


class DELPHICLASS TVrPercentPie;
class PASCALIMPLEMENTATION TVrPercentPie : public TVrPercentGraph 
{
	typedef TVrPercentGraph inherited;
	
protected:
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TVrPercentPie(Classes::TComponent* AOwner);
	
__published:
	__property Transparent ;
public:
	#pragma option push -w-inl
	/* TVrPercentGraph.Destroy */ inline __fastcall virtual ~TVrPercentPie(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vrgraphs */
using namespace Vrgraphs;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VrGraphs
