// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'VrTrackBar.pas' rev: 6.00

#ifndef VrTrackBarHPP
#define VrTrackBarHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <VrSystem.hpp>	// Pascal unit
#include <VrSysUtils.hpp>	// Pascal unit
#include <VrControls.hpp>	// Pascal unit
#include <VrClasses.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vrtrackbar
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TVrTrackBarOption { toActiveClick, toMouseClip, toHandPoint, toFixedPoints, toThumbOpaque };
#pragma option pop

typedef Set<TVrTrackBarOption, toActiveClick, toThumbOpaque>  TVrTrackBarOptions;

class DELPHICLASS TVrTrackBar;
class PASCALIMPLEMENTATION TVrTrackBar : public Vrcontrols::TVrCustomImageControl 
{
	typedef Vrcontrols::TVrCustomImageControl inherited;
	
private:
	int FMinValue;
	int FMaxValue;
	int FPosition;
	Vrcontrols::TVrProgressStyle FStyle;
	Vrcontrols::TVrOrientation FOrientation;
	TVrTrackBarOptions FOptions;
	int FFrequency;
	int FBorderWidth;
	Vrclasses::TVrBevel* FGutterBevel;
	int FGutterWidth;
	Graphics::TColor FGutterColor;
	Vrcontrols::TVrTickMarks FTickMarks;
	Graphics::TColor FTickColor;
	int FScaleOffset;
	Graphics::TColor FFocusColor;
	int FFocusOffset;
	int FBackImageIndex;
	int FThumbImageIndex;
	Vrsystem::TVrBitmapList* FBitmapList;
	Vrcontrols::TVrChangeLink* FBitmapListLink;
	Classes::TNotifyEvent FOnChange;
	int FHit;
	bool FClipOn;
	bool FFocused;
	#pragma pack(push, 1)
	Types::TRect FThumbRect;
	#pragma pack(pop)
	
	int FThumbWidth;
	int FThumbHeight;
	Graphics::TBitmap* FThumbImage;
	bool FThumbDown;
	bool FThumbHasMouse;
	Vrclasses::TVrNumGlyphs FThumbStates;
	void __fastcall SetMinValue(int Value);
	void __fastcall SetMaxValue(int Value);
	void __fastcall SetPosition(int Value);
	void __fastcall SetStyle(Vrcontrols::TVrProgressStyle Value);
	void __fastcall SetOrientation(Vrcontrols::TVrOrientation Value);
	void __fastcall SetOptions(TVrTrackBarOptions Value);
	void __fastcall SetFrequency(int Value);
	HIDESBASE void __fastcall SetBorderWidth(int Value);
	void __fastcall SetGutterWidth(int Value);
	void __fastcall SetGutterColor(Graphics::TColor Value);
	void __fastcall SetGutterBevel(Vrclasses::TVrBevel* Value);
	void __fastcall SetTickMarks(Vrcontrols::TVrTickMarks Value);
	void __fastcall SetTickColor(Graphics::TColor Value);
	void __fastcall SetScaleOffset(int Value);
	void __fastcall SetThumbStates(Vrclasses::TVrNumGlyphs Value);
	void __fastcall SetFocusColor(Graphics::TColor Value);
	void __fastcall SetFocusOffset(int Value);
	void __fastcall SetBackImageIndex(int Value);
	void __fastcall SetThumbImageIndex(int Value);
	void __fastcall SetBitmapList(Vrsystem::TVrBitmapList* Value);
	void __fastcall DrawScale(Graphics::TCanvas* Canvas, int Offset, int ThumbOffset, int RulerLength, int PointsStep, int PointsHeight, int ExtremePointsHeight);
	void __fastcall GutterBevelChanged(System::TObject* Sender);
	void __fastcall BitmapListChanged(System::TObject* Sender);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	HIDESBASE MESSAGE void __fastcall WMSetCursor(Messages::TWMSetCursor &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Msg);
	HIDESBASE MESSAGE void __fastcall CMFocusChanged(Controls::TCMFocusChanged &Message);
	HIDESBASE MESSAGE void __fastcall CMEnabledChanged(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	void __fastcall GetThumbImage(void);
	void __fastcall SetThumbTop(int ATop);
	void __fastcall SetThumbLeft(int ALeft);
	void __fastcall CenterThumb(void);
	virtual void __fastcall Paint(void);
	void __fastcall PaintThumb(void);
	DYNAMIC void __fastcall Change(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	int __fastcall GetViewWidth(void);
	int __fastcall GetOffsetByValue(int Value);
	int __fastcall GetValueByOffset(int Offset);
	Graphics::TBitmap* __fastcall GetBitmap(int Index);
	Types::TRect __fastcall GetSliderRect();
	int __fastcall GetMinIndent(const Types::TRect &Rect);
	void __fastcall SetThumbOffset(int Value);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	
public:
	__fastcall virtual TVrTrackBar(Classes::TComponent* AOwner);
	__fastcall virtual ~TVrTrackBar(void);
	
__published:
	__property int MaxValue = {read=FMaxValue, write=SetMaxValue, default=100};
	__property int MinValue = {read=FMinValue, write=SetMinValue, default=0};
	__property int Position = {read=FPosition, write=SetPosition, default=0};
	__property Vrcontrols::TVrOrientation Orientation = {read=FOrientation, write=SetOrientation, default=1};
	__property Vrcontrols::TVrProgressStyle Style = {read=FStyle, write=SetStyle, default=0};
	__property TVrTrackBarOptions Options = {read=FOptions, write=SetOptions, default=23};
	__property int Frequency = {read=FFrequency, write=SetFrequency, default=10};
	__property int BorderWidth = {read=FBorderWidth, write=SetBorderWidth, default=10};
	__property Vrclasses::TVrBevel* GutterBevel = {read=FGutterBevel, write=SetGutterBevel};
	__property int GutterWidth = {read=FGutterWidth, write=SetGutterWidth, default=9};
	__property Graphics::TColor GutterColor = {read=FGutterColor, write=SetGutterColor, default=0};
	__property Vrcontrols::TVrTickMarks TickMarks = {read=FTickMarks, write=SetTickMarks, default=1};
	__property Graphics::TColor TickColor = {read=FTickColor, write=SetTickColor, default=0};
	__property Vrclasses::TVrNumGlyphs ThumbStates = {read=FThumbStates, write=SetThumbStates, default=1};
	__property int BackImageIndex = {read=FBackImageIndex, write=SetBackImageIndex, default=-1};
	__property int ThumbImageIndex = {read=FThumbImageIndex, write=SetThumbImageIndex, default=-1};
	__property Vrsystem::TVrBitmapList* BitmapList = {read=FBitmapList, write=SetBitmapList};
	__property int ScaleOffset = {read=FScaleOffset, write=SetScaleOffset, default=5};
	__property Graphics::TColor FocusColor = {read=FFocusColor, write=SetFocusColor, default=0};
	__property int FocusOffset = {read=FFocusOffset, write=SetFocusOffset, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Align  = {default=0};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property Enabled  = {default=1};
	__property Color  = {default=-2147483643};
	__property Cursor  = {default=0};
	__property DragMode  = {default=0};
	__property DragKind  = {default=0};
	__property DragCursor  = {default=-12};
	__property ParentColor  = {default=1};
	__property ParentShowHint  = {default=1};
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=0};
	__property Visible  = {default=1};
	__property OnClick ;
	__property OnContextPopup ;
	__property OnEnter ;
	__property OnExit ;
	__property OnMouseMove ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnKeyDown ;
	__property OnKeyUp ;
	__property OnKeyPress ;
	__property OnDragOver ;
	__property OnEndDock ;
	__property OnDragDrop ;
	__property OnEndDrag ;
	__property OnStartDock ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TVrTrackBar(HWND ParentWindow) : Vrcontrols::TVrCustomImageControl(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vrtrackbar */
using namespace Vrtrackbar;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// VrTrackBar
